/*
 *
 * ----------
 * 
 * Copyright (C) 2007-2011 Yoshitaka Ohsawa All rights reserved.
 * This is free software with ABSOLUTELY NO WARRANTY.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * ----------
 */
package to.tetramorph.almanac;
import java.util.Calendar;
/**
 * 日付とムーンフェイス(新月、上弦、満月、下弦)を保存するクラス。
 * エニアグラムの九相を保存したりするのにも使う。
 */
public class MoonFace {

    private static final String [] faceNames = { "新月","上弦","満月","下弦" };
    public int face;
    public Calendar date;
    /**
     * @param date faceで指定した月相になる日。
     * @param face 0〜3で月の新月、上弦、満月、下弦を表す
     */
    public MoonFace(Calendar date,int face) {
        this.date = date;
        this.face = face;
    }
    /**
     * このオブジェクトの日付と月相を文字列で返す。
     */
    @Override
    public String toString() {
        return String.format("%tY/ %tm/%td %tT",date,date,date,date) ;
    }

    /** 24時間制で時刻文字列を返す。"0:00"〜"23:59" */

    public String getTime() {
        return String.format("%Tk:%TM",date,date,date).replaceAll("午","");
    }

    public String getName() {
        return faceNames[face];
    }
}
