/*
 *
 * ----------
 * 
 * Copyright (C) 2007-2011 Yoshitaka Ohsawa All rights reserved.
 * This is free software with ABSOLUTELY NO WARRANTY.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * ----------
 */
package to.tetramorph.almanac;

import java.util.*;
/**
 * 月を除いた惑星のイングレスの時期や、逆行や順行に転じる時期を保管するクラス。
 */
public class PlanetEvent {

    public int sign;
    public int state;
    public int planet;
    public Calendar date;

    /**
     * 日付、天体番号(SweConstに準じる)、
     * stateは0,1ならこのデータがイングレスの時期を表現していて、1なら逆行であること
     * を表す。
     * stateが2,3ならこのデータが逆行順行の切替時期を表現していて、
     * 3なら逆行に2なら順行に転じた事を表す。
     * signはその時の星座サインを表す。
     *
     * このクラスはフィールド変数に直接アクセスして使う。
     */
    public PlanetEvent(Calendar date, int planet, int state, int sign) {
        this.date = date;
        this.state = state;
        this.sign = sign;
        this.planet = planet;
    }
}
