/*
 * AspectCircleAdapter.java
 *
 * Created on 2007/10/08, 15:01
 *
 * ----------
 * 
 * Copyright (C) 2007-2011 Yoshitaka Ohsawa All rights reserved.
 * This is free software with ABSOLUTELY NO WARRANTY.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * ----------
 */

package to.tetramorph.starbase.chartparts;

/**
 * AspectCircleListenerのアダプタークラス。
 * @author 大澤義鷹
 */
public abstract class AspectCircleAdapter implements AspectCircleListener {
  /**
   * アスペクト円内のアスペクト線がクリックされた時に呼び出される。
   */
  public void aspectClicked(AspectCircleEvent evt) {
  }
  /**
   * アスペクト円内のアスペクト線がダブルクリックされた時に呼び出される。
   */
  public void aspectDoubleClicked(AspectCircleEvent evt) {
  }
  /**
   * アスペクト円内で、アスペクト線以外が左クリックされた時に呼び出される。
   */
  public void aspectCircleClicked(AspectCircleEvent evt) {
  }
  /**
   * アスペクト円内のアスペクト線にマウスカーソルが接触したときに呼び出される。
   */
  public void aspectOnCursor(AspectCircleEvent evt) {
  }
  
  /**
   * アスペクト円内のアスペクト線からマウスカーソルが離れたときに呼び出される。
   */
  public void aspectOutCursor(AspectCircleEvent evt) {
  }  
}
