/*
 * AspectCircleEvent.java
 *
 * Created on 2007/08/23, 10:14
 *
 * ----------
 * 
 * Copyright (C) 2007-2011 Yoshitaka Ohsawa All rights reserved.
 * This is free software with ABSOLUTELY NO WARRANTY.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * ----------
 */

package to.tetramorph.starbase.chartparts;

import java.awt.event.MouseEvent;
import to.tetramorph.starbase.lib.Aspect;

/**
 * AspectCircleで発生するイベント情報クラス。
 * @author 大澤義鷹
 */
public class AspectCircleEvent {
  Aspect aspect;
  MouseEvent mouseEvent;
  Object source;
  /**  
   * AspectCircleEvent オブジェクトを作成する 
   * @param aspect アスペクトオブジェクト
   * @param mouseEvent マウスイベント
   * @param source イベントの起きたオブジェクトを返す。
   */
  public AspectCircleEvent(Aspect aspect,MouseEvent mouseEvent,Object source) {
    this.aspect = aspect;
    this.mouseEvent = mouseEvent;
    this.source = source;
  }
  /**
   * マウスイベントの起きたアスペクトを返す。
   */
  public Aspect getAspect() {
    return aspect;
  }
  /**
   * マウスイベント情報を返す。
   */
  public MouseEvent getMouseEvent() {
    return mouseEvent;
  }
  /**
   * イベントの起きたオブジェクトを返す。
   */
  public Object getSource() {
    return source;
  }
}
