/*
 * PlanetEvent.java
 *
 * Created on 2007/06/06, 18:43
 *
 * ----------
 * 
 * Copyright (C) 2007-2011 Yoshitaka Ohsawa All rights reserved.
 * This is free software with ABSOLUTELY NO WARRANTY.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * ----------
 */

package to.tetramorph.starbase.chartparts;

import java.awt.event.MouseEvent;
import to.tetramorph.starbase.lib.Body;

/**
 * ホロスコープ円上の天体のイベント情報。
 * @author 大澤義鷹
 */
public class PlanetEvent {
  Body body;
  MouseEvent mouseEvent;
  Object source;
  double draggedAngle;
  /**  PlanetEvent オブジェクトを作成する */
  public PlanetEvent(Body body,MouseEvent mouseEvent,Object source) {
    this.body = body;
    this.mouseEvent = mouseEvent;
    this.source = source;
  }
  public PlanetEvent(Body body,MouseEvent mouseEvent,Object source,double draggedAngle) {
    this.body = body;
    this.mouseEvent = mouseEvent;
    this.source = source;
    this.draggedAngle = draggedAngle;
  }
  
  public Body getBody() {
    return body;
  }
  public MouseEvent getMouseEvent() {
    return mouseEvent;
  }
  public Object getSource() {
    return source;
  }
  public double getDraggedAngle() {
    return draggedAngle;
  }
}
