/*
 * SabianDialogHandler.java
 *
 * Created on 2007/03/20, 17:58
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 * ----------
 * 
 * Copyright (C) 2007-2011 Yoshitaka Ohsawa All rights reserved.
 * This is free software with ABSOLUTELY NO WARRANTY.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * ----------
 */

package to.tetramorph.starbase.util;

import java.util.List;
import to.tetramorph.starbase.lib.Body;

/**
 * SabianDialogはこのインターフェイスを実装しており、モジュールはこのインターフェイス
 * を使ってSabianDialogにアクセスする仕組み。直接SabianDialogのインスタンスを
 * 作成したりすることは禁止している。
 * @author 大澤義鷹
 */
public interface SabianDialogHandler {
    /**
     * 指定角度(0-359)のサビアンを選択する。
     */
    public void setSelect(int angle);

    /**
     * ダイアログを可視または不可視にする。
     */
    public void setVisible(boolean b);
    
    /**
     * ダイアログの可視化状態を返す。可視ならtrueを返す。
     */
    public boolean isVisible();
    
    /**
     * 天体シンボルを該当するサビアンに与える。
     */
    public void setBodyList(List<Body> bodyList);
    
    /**
     * 現在選択されている言語コードを返す。
     * @return Sabian.JPまたはSabian.ENのどちらか。
     */
    public int getLang();
}
