/*
 * HouseColorPanel.java
 *
 * Created on 2006/12/28, 6:47
 * ----------
 * 
 * Copyright (C) 2007-2011 Yoshitaka Ohsawa All rights reserved.
 * This is free software with ABSOLUTELY NO WARRANTY.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * ----------
 */

package to.tetramorph.starbase.widget;

import java.awt.Color;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.Enumeration;
import javax.swing.BorderFactory;
import javax.swing.JColorChooser;
import javax.swing.JLabel;
import javax.swing.JRadioButton;
import javax.swing.border.Border;

/**
 * 各ハウスの色を設定するパネル。
 * @author  大澤義鷹
 */
public class HouseColorPanel extends javax.swing.JPanel {
  private static final String title = "ハウスの色設定";
  JLabel [] houseLabels = new JLabel[13];
  JRadioButton [] radioButtons = new JRadioButton[13];
  /** Creates new form HouseColorPanel */
  public HouseColorPanel() {
    initComponents();
    init();
  }
  private void init() {
    houseLabels[1] = houseLabel1;
    houseLabels[2] = houseLabel2;
    houseLabels[3] = houseLabel3;
    houseLabels[4] = houseLabel4;
    houseLabels[5] = houseLabel5;
    houseLabels[6] = houseLabel6;
    houseLabels[7] = houseLabel7;
    houseLabels[8] = houseLabel8;
    houseLabels[9] = houseLabel9;
    houseLabels[10] = houseLabel10;
    houseLabels[11] = houseLabel11;
    houseLabels[12] = houseLabel12;
    for(int i=1; i<radioButtons.length; i++)
      houseLabels[i].addMouseListener(new MouseHandler(i));
    buttonGroup.add(radioButton1);
    buttonGroup.add(radioButton2);
    buttonGroup.add(radioButton3);
    buttonGroup.add(radioButton4);
    buttonGroup.add(radioButton5);
    buttonGroup.add(radioButton6);
    buttonGroup.add(radioButton7);
    buttonGroup.add(radioButton8);
    buttonGroup.add(radioButton9);
    buttonGroup.add(radioButton10);
    buttonGroup.add(radioButton11);
    buttonGroup.add(radioButton12);
    radioButtons[1] = radioButton1;
    radioButtons[2] = radioButton2;
    radioButtons[3] = radioButton3;
    radioButtons[4] = radioButton4;
    radioButtons[5] = radioButton5;
    radioButtons[6] = radioButton6;
    radioButtons[7] = radioButton7;
    radioButtons[8] = radioButton8;
    radioButtons[9] = radioButton9;
    radioButtons[10] = radioButton10;
    radioButtons[11] = radioButton11;
    radioButtons[12] = radioButton12;
    
    repeatButtonGroup.add(repeatRadioButton1);
    repeatButtonGroup.add(repeatRadioButton2);
    repeatButtonGroup.add(repeatRadioButton3);
    repeatButtonGroup.add(repeatRadioButton4);
  }
  //マウスハンドラー
  class MouseHandler extends MouseAdapter {
    int num;
    // オブジェクト作成時にシリアル番号を受け取る
    MouseHandler(int num) {
      this.num = num;
    }
    // ｼﾝﾎﾞﾙﾃﾞｨｽﾌﾟﾚｲ上でﾏｳｽｸﾘｯｸが発生したら、ﾗｼﾞｵﾎﾞﾀﾝ選択
    //public void mouseClicked(MouseEvent evt) {
    public void mouseReleased(MouseEvent evt) { 
      //if(enabled)
      //radioButtons[num].setSelected(true);
      Enumeration enu = buttonGroup.getElements();
      for(int i=1; enu.hasMoreElements(); i++) {
        JRadioButton button = (JRadioButton)enu.nextElement();
        if(i == num) {
          button.setSelected(true);
          break;
        }
      }
    }
  }
  /** ハウス選択ボタンがならんでいるパネルの背景色をセット */
  public void setBG(Color color) {
    houses.setBackground(color);
    for(int i=1; i<radioButtons.length; i++) {
      radioButtons[i].setBackground(color);
    }
  }
  //すべてのハウスに背景色セット
  private void setHouseBG(Color color) {
    //ラベルのOpaqueはtrueにセットしてないと色がつかないので注意(他のラベルも同じ)
    for(int i=1; i<houseLabels.length; i++) houseLabels[i].setBackground(color);
  }
  //すべてのハウスに前景色(文字色)セット
  private void setFG(Color color) {
    for(int i=1; i<houseLabels.length; i++) houseLabels[i].setForeground(color);
  }
  //フレーム色をセット(カスプ線の色)
  private void setFrame(Color color) {
    for(int i=1; i<houseLabels.length; i++) {
      Border b = BorderFactory.createLineBorder(color);
      houseLabels[i].setBorder(b);
    }
  }
  // 背景色と文字色をリピートコピーする。
  private void repeat(int count) {
    for(int i=count+1; i<houseLabels.length; i+= count) {
      for(int j=0; j<count; j++) {
        houseLabels[i+j].setBackground(houseLabels[j+1].getBackground());
        houseLabels[i+j].setForeground(houseLabels[j+1].getForeground());
      }
    }
  }
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc=" Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {
    javax.swing.JPanel allPanel;
    java.awt.GridBagConstraints gridBagConstraints;
    javax.swing.JPanel jPanel1;
    javax.swing.JPanel jPanel2;
    javax.swing.JPanel jPanel3;
    javax.swing.JPanel jPanel4;
    javax.swing.JPanel jPanel5;
    javax.swing.JPanel repeatPanel;

    buttonGroup = new javax.swing.ButtonGroup();
    repeatButtonGroup = new javax.swing.ButtonGroup();
    jPanel1 = new javax.swing.JPanel();
    jPanel2 = new javax.swing.JPanel();
    houses = new javax.swing.JPanel();
    houseLabel1 = new javax.swing.JLabel();
    houseLabel2 = new javax.swing.JLabel();
    houseLabel3 = new javax.swing.JLabel();
    houseLabel4 = new javax.swing.JLabel();
    houseLabel5 = new javax.swing.JLabel();
    houseLabel6 = new javax.swing.JLabel();
    houseLabel7 = new javax.swing.JLabel();
    houseLabel8 = new javax.swing.JLabel();
    houseLabel9 = new javax.swing.JLabel();
    houseLabel10 = new javax.swing.JLabel();
    houseLabel11 = new javax.swing.JLabel();
    houseLabel12 = new javax.swing.JLabel();
    radioButton1 = new javax.swing.JRadioButton();
    radioButton2 = new javax.swing.JRadioButton();
    radioButton3 = new javax.swing.JRadioButton();
    radioButton4 = new javax.swing.JRadioButton();
    radioButton5 = new javax.swing.JRadioButton();
    radioButton6 = new javax.swing.JRadioButton();
    radioButton7 = new javax.swing.JRadioButton();
    radioButton8 = new javax.swing.JRadioButton();
    radioButton9 = new javax.swing.JRadioButton();
    radioButton10 = new javax.swing.JRadioButton();
    radioButton11 = new javax.swing.JRadioButton();
    radioButton12 = new javax.swing.JRadioButton();
    jPanel3 = new javax.swing.JPanel();
    jPanel4 = new javax.swing.JPanel();
    allPanel = new javax.swing.JPanel();
    allBGButton = new javax.swing.JButton();
    allFGButton = new javax.swing.JButton();
    cuspButton = new javax.swing.JButton();
    jPanel5 = new javax.swing.JPanel();
    repeatPanel = new javax.swing.JPanel();
    repeatRadioButton1 = new javax.swing.JRadioButton();
    repeatRadioButton2 = new javax.swing.JRadioButton();
    repeatRadioButton3 = new javax.swing.JRadioButton();
    repeatRadioButton4 = new javax.swing.JRadioButton();
    repeatButton = new javax.swing.JButton();
    selectedBGButton = new javax.swing.JButton();
    selectedFGButton = new javax.swing.JButton();

    setLayout(new java.awt.BorderLayout());

    jPanel1.setLayout(new java.awt.GridLayout(1, 0));

    jPanel1.setBorder(javax.swing.BorderFactory.createEmptyBorder(8, 8, 8, 8));
    jPanel2.setLayout(new java.awt.GridLayout(1, 0));

    jPanel2.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
    houses.setLayout(new java.awt.GridBagLayout());

    houses.setBorder(javax.swing.BorderFactory.createEmptyBorder(8, 8, 8, 8));
    houseLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    houseLabel1.setText("<html><b>I</b></html>");
    houseLabel1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
    houseLabel1.setOpaque(true);
    houseLabel1.setPreferredSize(new java.awt.Dimension(30, 30));
    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.gridx = 0;
    gridBagConstraints.gridy = 1;
    gridBagConstraints.insets = new java.awt.Insets(0, 2, 0, 2);
    houses.add(houseLabel1, gridBagConstraints);

    houseLabel2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    houseLabel2.setText("<html><b>II</b></html>");
    houseLabel2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
    houseLabel2.setOpaque(true);
    houseLabel2.setPreferredSize(new java.awt.Dimension(30, 30));
    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.gridx = 1;
    gridBagConstraints.gridy = 1;
    gridBagConstraints.insets = new java.awt.Insets(0, 2, 0, 2);
    houses.add(houseLabel2, gridBagConstraints);

    houseLabel3.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    houseLabel3.setText("<html><b>III</b></html>");
    houseLabel3.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
    houseLabel3.setOpaque(true);
    houseLabel3.setPreferredSize(new java.awt.Dimension(30, 30));
    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.gridx = 2;
    gridBagConstraints.gridy = 1;
    gridBagConstraints.insets = new java.awt.Insets(0, 2, 0, 2);
    houses.add(houseLabel3, gridBagConstraints);

    houseLabel4.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    houseLabel4.setText("<html><b>IV</b></html>");
    houseLabel4.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
    houseLabel4.setOpaque(true);
    houseLabel4.setPreferredSize(new java.awt.Dimension(30, 30));
    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.gridx = 3;
    gridBagConstraints.gridy = 1;
    gridBagConstraints.insets = new java.awt.Insets(0, 2, 0, 2);
    houses.add(houseLabel4, gridBagConstraints);

    houseLabel5.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    houseLabel5.setText("<html><b>V</b></html>");
    houseLabel5.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
    houseLabel5.setOpaque(true);
    houseLabel5.setPreferredSize(new java.awt.Dimension(30, 30));
    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.gridx = 4;
    gridBagConstraints.gridy = 1;
    gridBagConstraints.insets = new java.awt.Insets(0, 2, 0, 2);
    houses.add(houseLabel5, gridBagConstraints);

    houseLabel6.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    houseLabel6.setText("<html><b>VI</b></html>");
    houseLabel6.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
    houseLabel6.setOpaque(true);
    houseLabel6.setPreferredSize(new java.awt.Dimension(30, 30));
    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.gridx = 5;
    gridBagConstraints.gridy = 1;
    gridBagConstraints.insets = new java.awt.Insets(0, 2, 0, 2);
    houses.add(houseLabel6, gridBagConstraints);

    houseLabel7.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    houseLabel7.setText("<html><b>VII</b></html>");
    houseLabel7.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
    houseLabel7.setOpaque(true);
    houseLabel7.setPreferredSize(new java.awt.Dimension(30, 30));
    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.gridx = 6;
    gridBagConstraints.gridy = 1;
    gridBagConstraints.insets = new java.awt.Insets(0, 2, 0, 2);
    houses.add(houseLabel7, gridBagConstraints);

    houseLabel8.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    houseLabel8.setText("<html><b>VIII</b></html>");
    houseLabel8.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
    houseLabel8.setOpaque(true);
    houseLabel8.setPreferredSize(new java.awt.Dimension(30, 30));
    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.gridx = 7;
    gridBagConstraints.gridy = 1;
    gridBagConstraints.insets = new java.awt.Insets(0, 2, 0, 2);
    houses.add(houseLabel8, gridBagConstraints);

    houseLabel9.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    houseLabel9.setText("<html><b>IX</b></html>");
    houseLabel9.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
    houseLabel9.setOpaque(true);
    houseLabel9.setPreferredSize(new java.awt.Dimension(30, 30));
    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.gridx = 8;
    gridBagConstraints.gridy = 1;
    gridBagConstraints.insets = new java.awt.Insets(0, 2, 0, 2);
    houses.add(houseLabel9, gridBagConstraints);

    houseLabel10.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    houseLabel10.setText("<html><b>X</b></html>");
    houseLabel10.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
    houseLabel10.setOpaque(true);
    houseLabel10.setPreferredSize(new java.awt.Dimension(30, 30));
    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.gridx = 9;
    gridBagConstraints.gridy = 1;
    gridBagConstraints.insets = new java.awt.Insets(0, 2, 0, 2);
    houses.add(houseLabel10, gridBagConstraints);

    houseLabel11.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    houseLabel11.setText("<html><b>XI</b></html>");
    houseLabel11.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
    houseLabel11.setOpaque(true);
    houseLabel11.setPreferredSize(new java.awt.Dimension(30, 30));
    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.gridx = 10;
    gridBagConstraints.gridy = 1;
    gridBagConstraints.insets = new java.awt.Insets(0, 2, 0, 2);
    houses.add(houseLabel11, gridBagConstraints);

    houseLabel12.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    houseLabel12.setText("<html><b>XII</b></html>");
    houseLabel12.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
    houseLabel12.setOpaque(true);
    houseLabel12.setPreferredSize(new java.awt.Dimension(30, 30));
    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.gridx = 11;
    gridBagConstraints.gridy = 1;
    gridBagConstraints.insets = new java.awt.Insets(0, 2, 0, 2);
    houses.add(houseLabel12, gridBagConstraints);

    radioButton1.setSelected(true);
    radioButton1.setActionCommand("1");
    radioButton1.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
    radioButton1.setMargin(new java.awt.Insets(0, 0, 0, 0));
    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.insets = new java.awt.Insets(0, 0, 4, 0);
    houses.add(radioButton1, gridBagConstraints);

    radioButton2.setActionCommand("2");
    radioButton2.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
    radioButton2.setMargin(new java.awt.Insets(0, 0, 0, 0));
    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.insets = new java.awt.Insets(0, 0, 4, 0);
    houses.add(radioButton2, gridBagConstraints);

    radioButton3.setActionCommand("3");
    radioButton3.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
    radioButton3.setMargin(new java.awt.Insets(0, 0, 0, 0));
    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.insets = new java.awt.Insets(0, 0, 4, 0);
    houses.add(radioButton3, gridBagConstraints);

    radioButton4.setActionCommand("4");
    radioButton4.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
    radioButton4.setMargin(new java.awt.Insets(0, 0, 0, 0));
    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.insets = new java.awt.Insets(0, 0, 4, 0);
    houses.add(radioButton4, gridBagConstraints);

    radioButton5.setActionCommand("5");
    radioButton5.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
    radioButton5.setMargin(new java.awt.Insets(0, 0, 0, 0));
    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.insets = new java.awt.Insets(0, 0, 4, 0);
    houses.add(radioButton5, gridBagConstraints);

    radioButton6.setActionCommand("6");
    radioButton6.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
    radioButton6.setMargin(new java.awt.Insets(0, 0, 0, 0));
    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.insets = new java.awt.Insets(0, 0, 4, 0);
    houses.add(radioButton6, gridBagConstraints);

    radioButton7.setActionCommand("7");
    radioButton7.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
    radioButton7.setMargin(new java.awt.Insets(0, 0, 0, 0));
    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.insets = new java.awt.Insets(0, 0, 4, 0);
    houses.add(radioButton7, gridBagConstraints);

    radioButton8.setActionCommand("8");
    radioButton8.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
    radioButton8.setMargin(new java.awt.Insets(0, 0, 0, 0));
    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.insets = new java.awt.Insets(0, 0, 4, 0);
    houses.add(radioButton8, gridBagConstraints);

    radioButton9.setActionCommand("9");
    radioButton9.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
    radioButton9.setMargin(new java.awt.Insets(0, 0, 0, 0));
    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.insets = new java.awt.Insets(0, 0, 4, 0);
    houses.add(radioButton9, gridBagConstraints);

    radioButton10.setActionCommand("10");
    radioButton10.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
    radioButton10.setMargin(new java.awt.Insets(0, 0, 0, 0));
    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.insets = new java.awt.Insets(0, 0, 4, 0);
    houses.add(radioButton10, gridBagConstraints);

    radioButton11.setActionCommand("11");
    radioButton11.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
    radioButton11.setMargin(new java.awt.Insets(0, 0, 0, 0));
    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.insets = new java.awt.Insets(0, 0, 4, 0);
    houses.add(radioButton11, gridBagConstraints);

    radioButton12.setActionCommand("12");
    radioButton12.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
    radioButton12.setMargin(new java.awt.Insets(0, 0, 0, 0));
    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.insets = new java.awt.Insets(0, 0, 4, 0);
    houses.add(radioButton12, gridBagConstraints);

    jPanel2.add(houses);

    jPanel1.add(jPanel2);

    add(jPanel1, java.awt.BorderLayout.NORTH);

    jPanel3.setLayout(new java.awt.GridBagLayout());

    jPanel4.setLayout(new java.awt.GridLayout(1, 0));

    jPanel4.setBorder(javax.swing.BorderFactory.createTitledBorder("\u5168\u3066\u306e\u30cf\u30a6\u30b9"));
    allPanel.setLayout(new java.awt.GridBagLayout());

    allPanel.setBorder(javax.swing.BorderFactory.createEmptyBorder(2, 8, 8, 8));
    allBGButton.setText("\u80cc\u666f\u8272");
    allBGButton.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
    allBGButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        allBGButtonActionPerformed(evt);
      }
    });

    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
    gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
    gridBagConstraints.insets = new java.awt.Insets(0, 0, 5, 0);
    allPanel.add(allBGButton, gridBagConstraints);

    allFGButton.setText("\u756a\u53f7\u3068\u30ab\u30b9\u30d7\u5ea6\u6570");
    allFGButton.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
    allFGButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        allFGButtonActionPerformed(evt);
      }
    });

    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.gridx = 0;
    gridBagConstraints.gridy = 1;
    gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
    gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
    gridBagConstraints.insets = new java.awt.Insets(0, 0, 5, 0);
    allPanel.add(allFGButton, gridBagConstraints);

    cuspButton.setText("\u30ab\u30b9\u30d7\u7dda\u8272");
    cuspButton.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
    cuspButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        cuspButtonActionPerformed(evt);
      }
    });

    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.gridx = 0;
    gridBagConstraints.gridy = 2;
    gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
    allPanel.add(cuspButton, gridBagConstraints);

    jPanel4.add(allPanel);

    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTH;
    jPanel3.add(jPanel4, gridBagConstraints);

    jPanel5.setLayout(new java.awt.GridLayout(1, 0));

    jPanel5.setBorder(javax.swing.BorderFactory.createTitledBorder("\u9078\u629e\u3057\u305f\u30cf\u30a6\u30b9"));
    repeatPanel.setLayout(new java.awt.GridBagLayout());

    repeatPanel.setBorder(javax.swing.BorderFactory.createEmptyBorder(2, 8, 8, 8));
    repeatRadioButton1.setSelected(true);
    repeatRadioButton1.setText("1\u5ba4\u304b\u30892\u8272\u5206\u30ea\u30d4\u30fc\u30c8");
    repeatRadioButton1.setActionCommand("0");
    repeatRadioButton1.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
    repeatRadioButton1.setMargin(new java.awt.Insets(0, 0, 0, 0));
    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.gridx = 0;
    gridBagConstraints.gridy = 2;
    gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
    gridBagConstraints.insets = new java.awt.Insets(2, 0, 2, 0);
    repeatPanel.add(repeatRadioButton1, gridBagConstraints);

    repeatRadioButton2.setText("1\u5ba4\u304b\u30893\u8272\u30ea\u30d4\u30fc\u30c8");
    repeatRadioButton2.setActionCommand("1");
    repeatRadioButton2.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
    repeatRadioButton2.setMargin(new java.awt.Insets(0, 0, 0, 0));
    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.gridx = 0;
    gridBagConstraints.gridy = 3;
    gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
    gridBagConstraints.insets = new java.awt.Insets(2, 0, 2, 0);
    repeatPanel.add(repeatRadioButton2, gridBagConstraints);

    repeatRadioButton3.setText("1\u5ba4\u304b\u30894\u8272\u30ea\u30d4\u30fc\u30c8");
    repeatRadioButton3.setActionCommand("2");
    repeatRadioButton3.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
    repeatRadioButton3.setMargin(new java.awt.Insets(0, 0, 0, 0));
    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.gridx = 0;
    gridBagConstraints.gridy = 4;
    gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
    gridBagConstraints.insets = new java.awt.Insets(2, 0, 2, 0);
    repeatPanel.add(repeatRadioButton3, gridBagConstraints);

    repeatRadioButton4.setText("1\u5ba4\u304b\u30896\u8272\u30ea\u30d4\u30fc\u30c8");
    repeatRadioButton4.setActionCommand("3");
    repeatRadioButton4.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
    repeatRadioButton4.setMargin(new java.awt.Insets(0, 0, 0, 0));
    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.gridx = 0;
    gridBagConstraints.gridy = 5;
    gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
    gridBagConstraints.insets = new java.awt.Insets(2, 0, 2, 0);
    repeatPanel.add(repeatRadioButton4, gridBagConstraints);

    repeatButton.setText("\u5b9f\u884c");
    repeatButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        repeatButtonActionPerformed(evt);
      }
    });

    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.gridx = 0;
    gridBagConstraints.gridy = 6;
    gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
    gridBagConstraints.insets = new java.awt.Insets(2, 0, 0, 0);
    repeatPanel.add(repeatButton, gridBagConstraints);

    selectedBGButton.setText("\u80cc\u666f\u8272");
    selectedBGButton.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
    selectedBGButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        selectedBGButtonActionPerformed(evt);
      }
    });

    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.gridx = 0;
    gridBagConstraints.gridy = 0;
    gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
    gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
    gridBagConstraints.insets = new java.awt.Insets(0, 0, 5, 0);
    repeatPanel.add(selectedBGButton, gridBagConstraints);

    selectedFGButton.setText("\u756a\u53f7\u3068\u30ab\u30b9\u30d7\u5ea6\u6570\u8272");
    selectedFGButton.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
    selectedFGButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        selectedFGButtonActionPerformed(evt);
      }
    });

    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.gridx = 0;
    gridBagConstraints.gridy = 1;
    gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
    gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
    gridBagConstraints.insets = new java.awt.Insets(0, 0, 8, 0);
    repeatPanel.add(selectedFGButton, gridBagConstraints);

    jPanel5.add(repeatPanel);

    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTH;
    gridBagConstraints.insets = new java.awt.Insets(0, 8, 0, 0);
    jPanel3.add(jPanel5, gridBagConstraints);

    add(jPanel3, java.awt.BorderLayout.CENTER);

  }// </editor-fold>//GEN-END:initComponents

  private void repeatButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_repeatButtonActionPerformed
    int n = Integer.parseInt( repeatButtonGroup.getSelection().getActionCommand() );
    if( n == 0) repeat(2);
    else if(n == 1) repeat(3);
    else if(n == 2) repeat(4);
    else if(n == 3) repeat(6);
  }//GEN-LAST:event_repeatButtonActionPerformed

  private void cuspButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cuspButtonActionPerformed
    Color color = JColorChooser.showDialog(this,title,Color.BLACK);
    if(color != null)
      setFrame(color);
  }//GEN-LAST:event_cuspButtonActionPerformed

  private void selectedFGButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_selectedFGButtonActionPerformed
    int n = Integer.parseInt( buttonGroup.getSelection().getActionCommand() );
    Color color = JColorChooser.showDialog(this,title,Color.WHITE);
    if(color != null) {
      houseLabels[n].setForeground(color);
    } 
  }//GEN-LAST:event_selectedFGButtonActionPerformed

  private void selectedBGButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_selectedBGButtonActionPerformed
    int n = Integer.parseInt( buttonGroup.getSelection().getActionCommand() );
    Color color = JColorChooser.showDialog(this,title,Color.WHITE);
    if(color != null) {
      houseLabels[n].setBackground(color);
    } 
  }//GEN-LAST:event_selectedBGButtonActionPerformed

  private void allFGButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_allFGButtonActionPerformed
    Color color = JColorChooser.showDialog(this,title,Color.WHITE);
    if(color != null)
      setFG(color);
  }//GEN-LAST:event_allFGButtonActionPerformed

  private void allBGButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_allBGButtonActionPerformed
    Color color = JColorChooser.showDialog(this,title,Color.WHITE);
    if(color != null)
      setHouseBG(color);
// TODO add your handling code here:
  }//GEN-LAST:event_allBGButtonActionPerformed
  
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JButton allBGButton;
  private javax.swing.JButton allFGButton;
  private javax.swing.ButtonGroup buttonGroup;
  private javax.swing.JButton cuspButton;
  private javax.swing.JLabel houseLabel1;
  private javax.swing.JLabel houseLabel10;
  private javax.swing.JLabel houseLabel11;
  private javax.swing.JLabel houseLabel12;
  private javax.swing.JLabel houseLabel2;
  private javax.swing.JLabel houseLabel3;
  private javax.swing.JLabel houseLabel4;
  private javax.swing.JLabel houseLabel5;
  private javax.swing.JLabel houseLabel6;
  private javax.swing.JLabel houseLabel7;
  private javax.swing.JLabel houseLabel8;
  private javax.swing.JLabel houseLabel9;
  private javax.swing.JPanel houses;
  private javax.swing.JRadioButton radioButton1;
  private javax.swing.JRadioButton radioButton10;
  private javax.swing.JRadioButton radioButton11;
  private javax.swing.JRadioButton radioButton12;
  private javax.swing.JRadioButton radioButton2;
  private javax.swing.JRadioButton radioButton3;
  private javax.swing.JRadioButton radioButton4;
  private javax.swing.JRadioButton radioButton5;
  private javax.swing.JRadioButton radioButton6;
  private javax.swing.JRadioButton radioButton7;
  private javax.swing.JRadioButton radioButton8;
  private javax.swing.JRadioButton radioButton9;
  private javax.swing.JButton repeatButton;
  private javax.swing.ButtonGroup repeatButtonGroup;
  private javax.swing.JRadioButton repeatRadioButton1;
  private javax.swing.JRadioButton repeatRadioButton2;
  private javax.swing.JRadioButton repeatRadioButton3;
  private javax.swing.JRadioButton repeatRadioButton4;
  private javax.swing.JButton selectedBGButton;
  private javax.swing.JButton selectedFGButton;
  // End of variables declaration//GEN-END:variables
  
}
