/*
 * HouseSystemComboBox.java
 *
 * Created on 2007/07/12, 23:39
 *
 * ----------
 * 
 * Copyright (C) 2007-2011 Yoshitaka Ohsawa All rights reserved.
 * This is free software with ABSOLUTELY NO WARRANTY.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * ----------
 */

package to.tetramorph.starbase.widget;

import javax.swing.JComboBox;
import to.tetramorph.starbase.lib.Const;

/**
 * ハウス分割法を選択するためのコンボボックス。
 * @author 大澤義鷹
 */
public class HouseSystemComboBox extends JComboBox {
  
  /**
   *  HouseSystemComboBox オブジェクトを作成する
   */
  public HouseSystemComboBox() {
    init();
  }
  private void init() {
    removeAllItems();
    for(int i=0; i < Const.HOUSE_SYSTEM_NAMES.length; i++)
      addItem(Const.HOUSE_SYSTEM_NAMES[i]);
  }
  /**
   * スイスエフェメリス用のハウス分割法の指定コードを返す。
   * ただしソーラーとソーラーサインはスイスエフェメリスには無い。
   * ソーラーは(int)'1'、ソーラーサインは(int)'2'が返る。
   */
  public char getSelectedCode() {
    return (char)Const.HOUSE_SYSTEM_CODES[getSelectedIndex()];
  }
  /**
   * スイスエフェメリス用のハウス分割法の指定コードによって、該当するアイテムを
   * 選択する。
   */
  public void setSelectedCode(char hsc) {
    for(int i=0; i < Const.HOUSE_SYSTEM_CODES.length; i++)
      if(Const.HOUSE_SYSTEM_CODES[i] == (int)hsc) {
        setSelectedIndex(i);
        break;
      }
  }
}
