/*
 * TabCloseButton.java
 *
 * Created on 2007/10/30, 4:16
 *
 * ----------
 * 
 * Copyright (C) 2007-2011 Yoshitaka Ohsawa All rights reserved.
 * This is free software with ABSOLUTELY NO WARRANTY.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * ----------
 */

package to.tetramorph.starbase.widget;

import java.awt.Dimension;
import java.awt.Insets;
import javax.swing.Icon;
import javax.swing.JRadioButton;
import to.tetramorph.util.IconLoader;

/**
 * [×]ボタン。
 * @author 大澤義鷹
 */
public class PanelCloseButton extends JRadioButton {
  private static final Icon normalIcon;
  private static final Icon pressedIcon;
  private static final Icon enteredIcon;
  private static final Insets zeroInsets = new Insets(0,0,0,0);
  private static final Dimension size = new Dimension(13,14);
  
  static {
    normalIcon = IconLoader.getImageIcon("/resources/close0.gif");
    pressedIcon = IconLoader.getImageIcon("/resources/close2.gif");
    enteredIcon =  IconLoader.getImageIcon("/resources/close1.gif");
  }
  
  /**  オブジェクトを作成する */
  public PanelCloseButton() {
    super();
    setIcon(normalIcon);
    setPressedIcon(pressedIcon);
    setRolloverIcon(enteredIcon);
    setRolloverSelectedIcon(enteredIcon);
    setMargin(zeroInsets);
    setPreferredSize(size);
    setMinimumSize(size);
    setMaximumSize(size);
    setContentAreaFilled(false);
  }
  
}
