/*
 * ImageSelection.java
 *
 * Created on 2008/10/21, 11:24
 *
 * ----------
 * 
 * Copyright (C) 2007-2011 Yoshitaka Ohsawa All rights reserved.
 * This is free software with ABSOLUTELY NO WARRANTY.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * ----------
 */

package to.tetramorph.util;

import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.awt.image.BufferedImage;
import java.io.IOException;

/**
 * Imageをクリップボードにコピーするためのもの。
 * @author 大澤義鷹
 */
public class ImageSelection implements Transferable {

    private BufferedImage image;
    private DataFlavor[] flavors;
    
    public ImageSelection( BufferedImage image ) {
        this.image = image;
        flavors = new DataFlavor[] { DataFlavor.imageFlavor };
    }
    
    public synchronized DataFlavor[] getTransferDataFlavors() {
        return flavors;
    }
    
    public boolean isDataFlavorSupported( DataFlavor flavor ) {
        return this.flavors[0].equals(flavor);
    }
    
    public synchronized Object getTransferData( DataFlavor flavor ) 
                              throws UnsupportedFlavorException, IOException {
        if ( ! flavors[0].equals( flavor ) ) {
            throw new UnsupportedFlavorException( flavor );
        }
        return image;
    }
}

