/*
 * AmateruSiteAction.java
 *
 * Created on 2008/11/21, 15:18
 *
 * ----------
 * 
 * Copyright (C) 2007-2011 Yoshitaka Ohsawa All rights reserved.
 * This is free software with ABSOLUTELY NO WARRANTY.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * ----------
 */

package to.tetramorph.starbase;

import java.awt.Desktop;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.net.URL;
import javax.swing.AbstractAction;
import javax.swing.JOptionPane;

/**
 * ヘルプメニューの中の「アマテルのホームページ」のメニューアクション。
 * 2011-07-29 システムプロパティからサポートURLを取得する方法に変更。
 * @author 大澤義孝
 */
public class AmateruSiteAction extends AbstractAction {
    private Frame owner;

    /**
     * AmateruSiteAction オブジェクトを作成する
     */
    public AmateruSiteAction( Frame owner ) {
        this.owner = owner;
    }
    @Override
    public void actionPerformed( ActionEvent evt ) {
        if ( Desktop.isDesktopSupported() ) {
            try {
                Desktop.getDesktop().browse(
                    new URL( System.getProperty("support_url")).toURI() );
            } catch ( Exception e ) {
                error("ブラウザが使用できません。\n" + e.toString() );
            }
        } else
            error( "お使いのプラットホームでJavaからのブラウザ起動はサポートされていません。");
    }

    private void error( String msg ) {
        JOptionPane.showMessageDialog( owner, msg, "ブラウザの起動に失敗",
                                                    JOptionPane.ERROR_MESSAGE );
    }

}
