/*
 * ChartDesktop.java
 *
 * Created on 2007/11/08, 20:39
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 * ----------
 * 
 * Copyright (C) 2007-2011 Yoshitaka Ohsawa All rights reserved.
 * This is free software with ABSOLUTELY NO WARRANTY.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * ----------
 */

package to.tetramorph.starbase;

import java.awt.Frame;
import java.util.List;
import to.tetramorph.starbase.lib.Natal;

/**
 * メインフレームと、データベースを切り分けるために用意したインターフェイス。
 * Mainにimplementされている。
 * JFrameを継承したメインフレームをそのままDatabasePanelに引き渡すやり方をしている
 * とメインフレームのGUIを別クラスで作り直した場合、DatabasePanel側も大きな修正
 * にせまられる。それを回避するためのもの。
 * @author 大澤義鷹
 */
interface ChartDesktop {
    
    public boolean isEmptyChartPane();
    
    public ChartPane openChartPane(List<Natal> list);
    
    public void setNatal( List<Natal> list,
                           ChartPane targetPane );
    
    public ChartPane[] getChartPanes();
    
    public void addNatal( List<Natal> list,
                            ChartPane targetPane );
    
    public void setTransit( List<Natal> list,
                              ChartPane targetChartPane );
    
    public boolean isDataBusy(int id);
    
    public Frame getFrame();
    public void setResultVisible( boolean b );
    
}
