/*
 * ChartPanelListener.java
 *
 * Created on 2007/11/09, 11:57
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 * ----------
 * 
 * Copyright (C) 2007-2011 Yoshitaka Ohsawa All rights reserved.
 * This is free software with ABSOLUTELY NO WARRANTY.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * ----------
 */

package to.tetramorph.starbase;

import java.awt.Component;
import javax.swing.Icon;

/**
 * ChartPaneのリスナ。ChartPane内でおきるイベントはこのリスナで通達される。
 * Mainの内部クラスChartPanelHandlerにimplementされている。
 * @author 大澤義鷹
 */
interface ChartPanelListener {
    public void setTitle( String title, Component c );
    public void setIcon( Icon icon, Component c );
    public void contentSelected( Component c );
    /**
     * チャートモジュールが切り替えられた時に呼び出される。
     * @param chartPane 切替が発生したChartPane
     */
    public void selectedChartModule(ChartPane chartPane);
    /**
     * 色の仕様設定メニューに変更があった場合に呼び出される。
     * 仕様カスタマイズ(仕様名の変更・削除・登録)が行われとき。
     */
    public void updateColorPreferenceMenu();
    /**
     * 計算の仕様設定メニューに変更があった場合に呼び出される。
     * 仕様カスタマイズ(仕様名の変更・削除・登録)が行われとき。
     */
    public void updateSpecificPreferenceMenu();
    
}
