/*
 * MenuManager.java
 *
 * Created on 2007/11/16, 10:11
 *
 * ----------
 * 
 * Copyright (C) 2007-2011 Yoshitaka Ohsawa All rights reserved.
 * This is free software with ABSOLUTELY NO WARRANTY.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * ----------
 */

package to.tetramorph.starbase;

import java.awt.Component;
import java.util.HashMap;
import java.util.Map;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JMenu;
import javax.swing.JMenuItem;

/**
 * メニューオブジェクトは名前をつけてこのオブジェクトに入れておく。
 * メニューが増えてくると、いくつかのクラスからメニューを相互参照する必要が出て
 * くるが、いちいちコンストラクタで参照を渡すのも煩わしい。名前をつけてグローバル
 * 変数のようなものとみなして対処する。
 * @author 大澤義鷹
 */
class MenuManager {
    private static final Map<String,Object> map = new HashMap<String,Object>();
    
    public static JMenuItem getMenuItem(String name) {
        return (JMenuItem)map.get(name);
    }
    
    public static JMenu getMenu(String name) {
        return (JMenu)map.get(name);
    }
    
    public static JButton getButton(String name) {
        return (JButton)map.get(name);
    }
    
    public static JComboBox getComboBox( String name ) {
        return (JComboBox)map.get( name );
    }
    public static Object get( String name ) {
        return map.get( name );
    }
    public static void put(String key,Object object) {
        map.put(key, object);
    }
}
