/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 * ----------
 * 
 * Copyright (C) 2007-2011 Yoshitaka Ohsawa All rights reserved.
 * This is free software with ABSOLUTELY NO WARRANTY.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * ----------
 */

/*
 * SplashPanel.java
 *
 * Created on 2009/11/14, 19:50:18
 */

package to.tetramorph.starbase;

import java.awt.BorderLayout;
import javax.swing.JButton;
import javax.swing.JProgressBar;

/**
 * アマテルのスプラッシュウィンドゥに表示されるパネル。
 * 鶏の絵と挺進パーがついている。
 * このパネルはSplashWindowにはめ込まれて使用される。
 * @author 大澤義鷹
 */
public class SplashPanel extends javax.swing.JPanel {
    /** Creates new form SplashPanel */
    public SplashPanel() {
        initComponents();
    }
    /**
     * スプラッシュの絵を消去し、かわりにエラーメッセージパネルを表示する。
     * @param errorMessage
     */
    public void setError(String errorMessage) {
        remove(niwatoriLabel);
//        getLayout().removeLayoutComponent(niwatoriLabel);
        add(errorPanel,BorderLayout.CENTER);
        validate();
        repaint();
        errorTextPane.setText(errorMessage);
    }
    public JProgressBar getJProgressBar() {
        return progressBar;
    }
    public JButton getJButton() {
        return acceptButton;
    }
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        errorPanel = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        errorTextPane = new javax.swing.JTextPane();
        acceptButton = new javax.swing.JButton();
        niwatoriLabel = new javax.swing.JLabel();
        progressBar = new javax.swing.JProgressBar();

        errorPanel.setLayout(new java.awt.GridBagLayout());

        jLabel1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/resources/error_egg.png"))); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTH;
        errorPanel.add(jLabel1, gridBagConstraints);

        jScrollPane1.setViewportView(errorTextPane);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        errorPanel.add(jScrollPane1, gridBagConstraints);

        acceptButton.setMnemonic('Y');
        acceptButton.setText("了解(Y)");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.SOUTH;
        gridBagConstraints.insets = new java.awt.Insets(4, 0, 4, 0);
        errorPanel.add(acceptButton, gridBagConstraints);

        setLayout(new java.awt.BorderLayout());

        niwatoriLabel.setIcon(new javax.swing.ImageIcon(getClass().getResource("/resources/splash_v2.png"))); // NOI18N
        add(niwatoriLabel, java.awt.BorderLayout.CENTER);

        progressBar.setStringPainted(true);
        add(progressBar, java.awt.BorderLayout.SOUTH);
    }// </editor-fold>//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton acceptButton;
    private javax.swing.JPanel errorPanel;
    private javax.swing.JTextPane errorTextPane;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JLabel niwatoriLabel;
    private javax.swing.JProgressBar progressBar;
    // End of variables declaration//GEN-END:variables

}
