/*
 * InnerPanel.java
 *
 * Created on 2007/11/07, 19:29
 * ----------
 * 
 * Copyright (C) 2007-2011 Yoshitaka Ohsawa All rights reserved.
 * This is free software with ABSOLUTELY NO WARRANTY.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * ----------
 */

package to.tetramorph.starbase.multisplit;

import java.awt.BorderLayout;
import java.awt.Component;

/**
 * タイトルバーがついたパネルで、バーにはクローズボタンなどをつけることができる。
 * はめ込みモードのときのデータベースパネルと、マニューバパネルについている
 * タイトルバーはこのパネルによる。
 * マニューバパネルの日時入力フォームは北寄せで配置されている。
 * はめこみモードのデータベースは北寄せで配置するとスクロールバーが正しくレイア
 * ウトされず範囲をオーバーしてしまったりするので、中央寄せで配置する。
 * @author  大澤義鷹
 */
public class InnerPanel extends javax.swing.JPanel {
  
    Component component;
    /** Creates new form InnerPanel */
    public InnerPanel() {
        initComponents();
    }
    /**
     * 配置方向を指定して、コンポーネントをセットする。
     * orientationにはBorderLayoutのCENTER,LEFT,RIGHT等を指定する。
     */
    public void setComponent(Component c,String orientation) {
        if(c == null) {
            if( component != null) panel.remove(component);
            return;
        }
        if( component != null ) panel.remove(component);
        panel.add( c, orientation);
        component = c;
    }
    /**
     * コンポーネントを北寄せで配置する。
     */
    public void setComponent(Component c) {
        setComponent(c,BorderLayout.NORTH);
    }
    /**
     * コンポーネントを中央に配置する。
     */
    public void setScrollableComponent(Component c) {
        setComponent(c,BorderLayout.CENTER);
    }
//    public void setComponent(Component c) {
//        if(c == null) {
//            if( component != null) panel.remove(component);
//            return;
//        }
//        if( component != null ) panel.remove(component);
//        panel.add(c,BorderLayout.NORTH);
//        component = c;
//    }
    /**
     * セットされているコンポーネントを返す。
     */
    public Component getComponent() {
        return component;
    }
  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc=" Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {
    bar = new to.tetramorph.starbase.multisplit.PanelBar();
    panel = new javax.swing.JPanel();

    setLayout(new java.awt.BorderLayout());

    add(bar, java.awt.BorderLayout.NORTH);

    panel.setLayout(new java.awt.BorderLayout());

    add(panel, java.awt.BorderLayout.CENTER);

  }// </editor-fold>//GEN-END:initComponents
  
  /**
   * このパネルについているタイトルバーのインスタンス
   */
  // Variables declaration - do not modify//GEN-BEGIN:variables
  public to.tetramorph.starbase.multisplit.PanelBar bar;
  private javax.swing.JPanel panel;
  // End of variables declaration//GEN-END:variables
  
}
