/*
 * Main.java
 * Created on 2011/07/31, 8:33:50.
 * ----------
 * 
 * Copyright (C) 2007-2011 Yoshitaka Ohsawa All rights reserved.
 * This is free software with ABSOLUTELY NO WARRANTY.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA
 * 
 * ----------
 */
package to.tetramorph.fontchooser;

import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.UIManager;

/**
 * フォントチューザーのデモを行う。
 * @author ohsawa
 */
public class Main {

    private static JFrame frame = new JFrame();

    public static void createAndShowGUI() {
        if ( System.getProperty("os.name").indexOf("Windows") >= 0) {
            try {
            UIManager.setLookAndFeel(
                 "com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
            } catch ( Exception e ) { }
        }
        JButton button = new JButton("TEST");
        JPanel pane = new JPanel(new FlowLayout());
        pane.add(button);
        ActionListener listener = new ActionListener() {
            Font font = null;
            //TESTボタンが押されたら、ダイアログを開く
            @Override
            public void actionPerformed(ActionEvent e) {
                if ( font == null ) font = frame.getFont();
                Font resFont = FontChooser.showDialog(frame,font);
                if (resFont == null) {
                    System.out.println("選択は中止されました");
                } else {
                    System.out.println(resFont + "が選択されました。");
                    font = resFont;
                }
            }
        };
        button.addActionListener(listener);
        frame.setTitle("フォントチューザーダイアログのテスト");
        frame.getRootPane().setDefaultButton(button);
        frame.add(pane);
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.pack();
        frame.setLocationRelativeTo(null);
        frame.setVisible(true);

    }
    /**
     * フォントチューザーのデモを行う。引数はなし。
     */
    public static void main( String [] args ) {
        java.awt.EventQueue.invokeLater( new Runnable() {
            @Override
            public void run() {
                createAndShowGUI();
            }
        });
    }
}
